diff --git a/mod/quiz/report/statistics/report.php b/mod/quiz/report/statistics/report.php
index ec076da..7778ed3 100644
--- a/mod/quiz/report/statistics/report.php
+++ b/mod/quiz/report/statistics/report.php
@@ -195,7 +195,7 @@ class quiz_statistics_report extends quiz_default_report {
             $questioninfotable = new html_table();
             $questioninfotable->align = array('center', 'center');
             $questioninfotable->width = '60%';
-            $questioninfotable->add_class('generaltable titlesleft');
+            $questioninfotable->attributes['class'] = 'generaltable titlesleft';
 
             $questioninfotable->data = array();
             $questioninfotable->data[] = array(get_string('modulename', 'quiz'), $quiz->name);
@@ -206,7 +206,7 @@ class quiz_statistics_report extends quiz_default_report {
             $questionstatstable = new html_table();
             $questionstatstable->align = array('center', 'center');
             $questionstatstable->width = '60%';
-            $questionstatstable->add_class('generaltable titlesleft');
+            $questionstatstable->attributes['class'] = 'generaltable titlesleft';
 
             unset($datumfromtable['number']);
             unset($datumfromtable['icon']);
@@ -225,12 +225,12 @@ class quiz_statistics_report extends quiz_default_report {
                 $questionstatstable->data[] = array($labels[$item], $value);
             }
             echo $OUTPUT->heading(get_string('questioninformation', 'quiz_statistics'));
-            echo $OUTPUT->table($questioninfotable);
+            echo html_writer::table($questioninfotable);
 
             echo $OUTPUT->box(format_text($question->questiontext, $question->questiontextformat).$actions, 'boxaligncenter generalbox boxwidthnormal mdl-align');
 
             echo $OUTPUT->heading(get_string('questionstatistics', 'quiz_statistics'));
-            echo $OUTPUT->table($questionstatstable);
+            echo html_writer::table($questionstatstable);
 
         } else {
             $this->qtable->export_class_instance($this->table->export_class_instance());
@@ -422,7 +422,7 @@ class quiz_statistics_report extends quiz_default_report {
             $quizinformationtablehtml .= $OUTPUT->help_icon('tableexportformats', get_string('tableexportformats', 'table'));
             $quizinformationtablehtml .= '</div></form>';
         }
-        $quizinformationtablehtml .= $OUTPUT->table($quizinformationtable);
+        $quizinformationtablehtml .= html_writer::table($quizinformationtable);
         if (!$this->table->is_downloading()){
             echo $quizinformationtablehtml;
         } elseif ($everything) {
diff --git a/mod/quiz/summary.php b/mod/quiz/summary.php
index 3e39c00..1c5fbac 100644
--- a/mod/quiz/summary.php
+++ b/mod/quiz/summary.php
@@ -77,7 +77,7 @@ echo $OUTPUT->heading($title);
 
 /// Prepare the summary table header
 $table = new html_table();
-$table->add_class('generaltable quizsummaryofattempt boxaligncenter');
+$table->attributes['class'] = 'generaltable quizsummaryofattempt boxaligncenter';
 $table->head = array(get_string('question', 'quiz'), get_string('status', 'quiz'));
 $table->align = array('left', 'left');
 $table->size = array('', '');
@@ -109,7 +109,7 @@ foreach ($attemptobj->get_question_iterator() as $number => $question) {
 }
 
 /// Print the summary table.
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 /// countdown timer
 echo $attemptobj->get_timer_html();
diff --git a/mod/quiz/view.php b/mod/quiz/view.php
index 8e77cbd..dc03895 100644
--- a/mod/quiz/view.php
+++ b/mod/quiz/view.php
@@ -181,7 +181,7 @@
 
         // Prepare table header
         $table = new html_table();
-        $table->set_classes('generaltable quizattemptsummary');
+        $table->attributes['class'] = 'generaltable quizattemptsummary';
         $table->head = array();
         $table->align = array();
         $table->size = array();
@@ -298,7 +298,7 @@
                 $table->data[$attempt->attempt] = $row;
             }
         } // End of loop over attempts.
-        echo $OUTPUT->table($table);
+        echo html_writer::table($table);
     }
 
 /// Print information about the student's best score for this quiz if possible.
diff --git a/mod/resource/index.php b/mod/resource/index.php
index 121b5ef..fe937b9 100644
--- a/mod/resource/index.php
+++ b/mod/resource/index.php
@@ -54,7 +54,7 @@ if (!$resources = get_all_instances_in_course('resource', $course)) {
 }
 
 $table = new html_table();
-$table->set_classes(array('generaltable', 'mod_index'));
+$table->attributes['class'] = 'generaltable mod_index';
 
 if ($course->format == 'weeks') {
     $table->head  = array ($strweek, $strname, $strintro);
@@ -100,6 +100,6 @@ foreach ($resources as $resource) {
         format_module_intro('resource', $resource, $cm->id));
 }
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 echo $OUTPUT->footer();
diff --git a/mod/scorm/index.php b/mod/scorm/index.php
index 0e6fbb2..6731c66 100755
--- a/mod/scorm/index.php
+++ b/mod/scorm/index.php
@@ -96,7 +96,7 @@
 
     echo "<br />";
 
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
 
     echo $OUTPUT->footer();
 
diff --git a/mod/scorm/report.php b/mod/scorm/report.php
index 36fe6d7..4911106 100755
--- a/mod/scorm/report.php
+++ b/mod/scorm/report.php
@@ -198,7 +198,7 @@
                 if (has_capability('mod/scorm:deleteresponses',$contextmodule)) {
                     echo '<form id="attemptsform" method="post" action="'.$FULLSCRIPT.'" onsubmit="var menu = document.getElementById(\'menuaction\'); return (menu.options[menu.selectedIndex].value == \'delete\' ? \''.addslashes_js(get_string('deleteattemptcheck','quiz')).'\' : true);">';
                     echo '<input type="hidden" name="id" value="'.$id.'">';
-                    echo $OUTPUT->table($table);
+                    echo html_writer::table($table);
                     echo '<a href="javascript:select_all_in(\'DIV\',null,\'scormtablecontainer\');">'.get_string('selectall', 'quiz').'</a> / ';
                     echo '<a href="javascript:deselect_all_in(\'DIV\',null,\'scormtablecontainer\');">'.get_string('selectnone', 'quiz').'</a> ';
                     echo '&nbsp;&nbsp;';
@@ -210,7 +210,7 @@
                     echo '<input type="submit" value="'.get_string('go').'" /></div></noscript>';
                     echo '</form>';
                 } else {
-                    echo $OUTPUT->table($table);
+                    echo html_writer::table($table);
                 }
                 echo '</div>';
             } else {
@@ -272,7 +272,7 @@
                             }
                             $table->data[] = $row;
                         }
-                        echo $OUTPUT->table($table);
+                        echo html_writer::table($table);
                     }
                 }
             } else {
@@ -347,7 +347,7 @@
             }
             if ($existelements) {
                 echo '<h3>'.get_string('general','scorm').'</h3>';
-                echo $OUTPUT->table($table);
+                echo html_writer::table($table);
             }
 
             // Print Interactions data
@@ -389,7 +389,7 @@
             }
             if ($existinteraction) {
                 echo '<h3>'.get_string('interactions','scorm').'</h3>';
-                echo $OUTPUT->table($table);
+                echo html_writer::table($table);
             }
 
             // Print Objectives data
@@ -433,7 +433,7 @@
             }
             if ($existobjective) {
                 echo '<h3>'.get_string('objectives','scorm').'</h3>';
-                echo $OUTPUT->table($table);
+                echo html_writer::table($table);
             }
             $table = new html_table();
             $table->head = array(get_string('element','scorm'), get_string('value','scorm'));
@@ -461,7 +461,7 @@
             }
             if ($existelements) {
                 echo '<h3>'.get_string('othertracks','scorm').'</h3>';
-                echo $OUTPUT->table($table);
+                echo html_writer::table($table);
             }
             echo $OUTPUT->box_end();
         } else {
diff --git a/mod/survey/index.php b/mod/survey/index.php
index e601fed..8083a66 100644
--- a/mod/survey/index.php
+++ b/mod/survey/index.php
@@ -80,7 +80,7 @@
     }
 
     echo "<br />";
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
     echo $OUTPUT->footer();
 
 
diff --git a/mod/survey/lib.php b/mod/survey/lib.php
index 36ae54e..3675006 100644
--- a/mod/survey/lib.php
+++ b/mod/survey/lib.php
@@ -191,7 +191,7 @@ function survey_user_complete($course, $user, $mod, $survey) {
                 }
                 $table->data[] = array("<b>$questiontext</b>", $answertext);
             }
-            echo $OUTPUT->table($table);
+            echo html_writer::table($table);
 
         } else {
 
@@ -475,7 +475,7 @@ function survey_print_all_responses($cmid, $results, $courseid) {
                userdate($a->time));
     }
 
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
 }
 
 /**
diff --git a/mod/survey/report.php b/mod/survey/report.php
index 18078fe..6cf6e5f 100644
--- a/mod/survey/report.php
+++ b/mod/survey/report.php
@@ -302,7 +302,7 @@
 
                     $table->data[] = array($contents);
 
-                    echo $OUTPUT->table($table);
+                    echo html_writer::table($table);
 
                     echo $OUTPUT->spacer(array('height'=>30)); // should be done with CSS instead
                 }
@@ -354,7 +354,7 @@
             }
         }
 
-        echo $OUTPUT->table($table);
+        echo html_writer::table($table);
 
         break;
 
@@ -440,7 +440,7 @@
                      $table->head = array(get_string($question->text, "survey"));
                      $table->align = array ("left");
                      $table->data[] = array(s($answer->answer1)); // no html here, just plain text
-                     echo $OUTPUT->table($table);
+                     echo html_writer::table($table);
                      echo $OUTPUT->spacer(30);
                  }
              }
diff --git a/mod/survey/view.php b/mod/survey/view.php
index e70bb30..9fb517a 100644
--- a/mod/survey/view.php
+++ b/mod/survey/view.php
@@ -115,7 +115,7 @@
                         $table->head = array(get_string($question->text, "survey"));
                         $table->align = array ("left");
                         $table->data[] = array(s($answer->answer1));//no html here, just plain text
-                        echo $OUTPUT->table($table);
+                        echo html_writer::table($table);
                         echo $OUTPUT->spacer(clone($spacer)) . '<br />';
                     }
                 }
diff --git a/mod/url/index.php b/mod/url/index.php
index 7f054f2..ed1774e 100644
--- a/mod/url/index.php
+++ b/mod/url/index.php
@@ -54,7 +54,7 @@ if (!$urls = get_all_instances_in_course('url', $course)) {
 }
 
 $table = new html_table();
-$table->set_classes(array('generaltable', 'mod_index'));
+$table->attributes['class'] = 'generaltable mod_index';
 
 if ($course->format == 'weeks') {
     $table->head  = array ($strweek, $strname, $strintro);
@@ -100,6 +100,6 @@ foreach ($urls as $url) {
         format_module_intro('url', $url, $cm->id));
 }
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 echo $OUTPUT->footer();
diff --git a/mod/wiki/index.php b/mod/wiki/index.php
index 222db90..c5fdf3c 100644
--- a/mod/wiki/index.php
+++ b/mod/wiki/index.php
@@ -101,7 +101,7 @@
 
     echo "<br />";
 
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
 
 /// Finish the page
 
diff --git a/mod/workshop/allocation/manual/renderer.php b/mod/workshop/allocation/manual/renderer.php
index a2da4d2..ab04d19 100644
--- a/mod/workshop/allocation/manual/renderer.php
+++ b/mod/workshop/allocation/manual/renderer.php
@@ -54,7 +54,7 @@ class workshopallocation_manual_renderer extends plugin_renderer_base  {
         $reviewers  =  array_map('fullname', $reviewers);
 
         $table              = new html_table();
-        $table->set_classes('allocations');
+        $table->attributes['class'] = 'allocations';
         $table->head        = array(get_string('participantreviewedby', 'workshop'),
                                     get_string('participant', 'workshop'),
                                     get_string('participantrevierof', 'workshop'));
@@ -77,7 +77,7 @@ class workshopallocation_manual_renderer extends plugin_renderer_base  {
             $table->data[] = $row;
         }
 
-        return $this->output->container($this->output->table($table), 'manual-allocator');
+        return $this->output->container(html_writer::table($table), 'manual-allocator');
     }
 
     /**
diff --git a/mod/workshop/renderer.php b/mod/workshop/renderer.php
index 905d30d..e09524d 100644
--- a/mod/workshop/renderer.php
+++ b/mod/workshop/renderer.php
@@ -362,11 +362,11 @@ class mod_workshop_renderer extends plugin_renderer_base {
             throw new coding_exception('you must provide the prepared user plan to be rendered');
         }
         $table = new html_table();
-        $table->set_classes('userplan');
+        $table->attributes['class'] = 'userplan';
         $table->head = array();
         $table->colclasses = array();
         $row = new html_table_row();
-        $row->set_classes('phasetasks');
+        $row->attributes['class'] = 'phasetasks';
         foreach ($plan as $phasecode => $phase) {
             $title = html_writer::tag('span', $phase->title);
             $actions = '';
@@ -394,7 +394,7 @@ class mod_workshop_renderer extends plugin_renderer_base {
         }
         $table->data = array($row);
 
-        return $this->output->table($table);
+        return html_writer::table($table);
     }
 
     /**
@@ -450,7 +450,7 @@ class mod_workshop_renderer extends plugin_renderer_base {
         }
 
         $table = new html_table();
-        $table->set_classes('grading-report');
+        $table->attributes['class'] = 'grading-report';
 
         $sortbyfirstname = $this->sortable_heading(get_string('firstname'), 'firstname', $options->sortby, $options->sorthow);
         $sortbylastname = $this->sortable_heading(get_string('lastname'), 'lastname', $options->sortby, $options->sorthow);
@@ -509,7 +509,7 @@ class mod_workshop_renderer extends plugin_renderer_base {
                     $cell = new html_table_cell();
                     $cell->text = $this->grading_report_participant($participant, $userinfo);
                     $cell->rowspan = $numoftrs;
-                    $cell->add_class('participant');
+                    $cell->attributes['class'] = 'participant';
                     $row->cells[] = $cell;
                 }
                 // column #2 - submission - spans over all rows
@@ -517,7 +517,7 @@ class mod_workshop_renderer extends plugin_renderer_base {
                     $cell = new html_table_cell();
                     $cell->text = $this->grading_report_submission($participant);
                     $cell->rowspan = $numoftrs;
-                    $cell->add_class('submission');
+                    $cell->attributes['class'] = 'submission';
                     $row->cells[] = $cell;
                 }
                 // column #3 - received grades
@@ -528,11 +528,11 @@ class mod_workshop_renderer extends plugin_renderer_base {
                     $cell->text = $this->grading_report_assessment($assessment, $options->showreviewernames, $userinfo,
                             get_string('gradereceivedfrom', 'workshop'));
                     $cell->rowspan = $spanreceived;
-                    $cell->add_class('receivedgrade');
+                    $cell->attributes['class'] = 'receivedgrade';
                     if (is_null($assessment) or is_null($assessment->grade)) {
-                        $cell->add_class('null');
+                        $cell->attributes['class'] .= ' null';
                     } else {
-                        $cell->add_class('notnull');
+                        $cell->attributes['class'] .= ' notnull';
                     }
                     $row->cells[] = $cell;
                 }
@@ -541,7 +541,7 @@ class mod_workshop_renderer extends plugin_renderer_base {
                     $cell = new html_table_cell();
                     $cell->text = $this->grading_report_grade($participant->submissiongrade, $participant->submissiongradeover);
                     $cell->rowspan = $numoftrs;
-                    $cell->add_class('submissiongrade');
+                    $cell->attributes['class'] = 'submissiongrade';
                     $row->cells[] = $cell;
                 }
                 // column #5 - given grades
@@ -552,11 +552,11 @@ class mod_workshop_renderer extends plugin_renderer_base {
                     $cell->text = $this->grading_report_assessment($assessment, $options->showauthornames, $userinfo,
                             get_string('gradegivento', 'workshop'));
                     $cell->rowspan = $spangiven;
-                    $cell->add_class('givengrade');
+                    $cell->attributes['class'] = 'givengrade';
                     if (is_null($assessment) or is_null($assessment->grade)) {
-                        $cell->add_class('null');
+                        $cell->attributes['class'] .= ' null';
                     } else {
-                        $cell->add_class('notnull');
+                        $cell->attributes['class'] .= ' notnull';
                     }
                     $row->cells[] = $cell;
                 }
@@ -565,7 +565,7 @@ class mod_workshop_renderer extends plugin_renderer_base {
                     $cell = new html_table_cell();
                     $cell->text = $this->grading_report_grade($participant->gradinggrade);
                     $cell->rowspan = $numoftrs;
-                    $cell->add_class('gradinggrade');
+                    $cell->attributes['class'] = 'gradinggrade';
                     $row->cells[] = $cell;
                 }
 
@@ -573,7 +573,7 @@ class mod_workshop_renderer extends plugin_renderer_base {
             }
         }
 
-        return $this->output->table($table);
+        return html_writer::table($table);
     }
 
     /**
diff --git a/question/type/questiontype.php b/question/type/questiontype.php
index e7ccc4d..796f4b6 100644
--- a/question/type/questiontype.php
+++ b/question/type/questiontype.php
@@ -1144,7 +1144,7 @@ class default_questiontype {
             }
             $table->data[] = $data;
         }
-        return $OUTPUT->table($table);
+        return html_writer::table($table);
     }
 
     /**
diff --git a/repository/lib.php b/repository/lib.php
index e60f6a0..2add7b8 100644
--- a/repository/lib.php
+++ b/repository/lib.php
@@ -1083,7 +1083,7 @@ abstract class repository {
                 $alreadyplugins[] = $i->name;
             }
         }
-        $output .= $OUTPUT->table($table);
+        $output .= html_writer::table($table);
         $instancehtml = '<div>';
         $addable = 0;
 
diff --git a/search/stats.php b/search/stats.php
index 3942fa8..2700b59 100644
--- a/search/stats.php
+++ b/search/stats.php
@@ -105,7 +105,7 @@ require_once($CFG->dirroot.'/search/lib.php');
             }
         }
 
-        echo $OUTPUT->table($admin_table);
+        echo html_writer::table($admin_table);
         echo $OUTPUT->spacer(array('height'=>20, 'br'=>true)); // should be done with CSS instead
         echo $OUTPUT->heading($solutionsstr);
 
@@ -120,7 +120,7 @@ require_once($CFG->dirroot.'/search/lib.php');
         $admin_table->data[] = array($runindexerteststr, '<a href="tests/index.php" target="_blank">tests/index.php</a>');
         $admin_table->data[] = array($runindexerstr, '<a href="indexersplash.php" target="_blank">indexersplash.php</a>');
 
-        echo $OUTPUT->table($admin_table);
+        echo html_writer::table($admin_table);
         echo $OUTPUT->spacer($spacer) . '<br />';
     }
 
@@ -161,7 +161,7 @@ require_once($CFG->dirroot.'/search/lib.php');
     }
 
     echo $OUTPUT->heading($databasestatestr);
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
 
     echo $OUTPUT->box_end();
     echo $OUTPUT->box_end();
diff --git a/theme/index.php b/theme/index.php
index 3a00b4a..f6f75f0 100644
--- a/theme/index.php
+++ b/theme/index.php
@@ -106,7 +106,7 @@ foreach ($themes as $themename => $themedir) {
     }
 }
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 
 echo $OUTPUT->footer();
 
diff --git a/user/addnote.php b/user/addnote.php
index 9ec1f2a..7e4f782 100644
--- a/user/addnote.php
+++ b/user/addnote.php
@@ -116,7 +116,7 @@ foreach ($users as $k => $v) {
         $checkbox
     );
 }
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 echo '<div style="width:100%;text-align:center;"><input type="submit" value="' . get_string('savechanges'). '" /></div></form>';
 echo $OUTPUT->footer();
 
diff --git a/user/extendenrol.php b/user/extendenrol.php
index c08b62e..0054317 100644
--- a/user/extendenrol.php
+++ b/user/extendenrol.php
@@ -181,7 +181,7 @@ foreach ($_POST as $k => $v) {
                 $checkbox2);
     }
 }
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 echo "\n<div style=\"width:100%;text-align:center;\"><input type=\"submit\" value=\"".get_string('savechanges')."\" /></div>\n</form>\n";
 
 echo $OUTPUT->footer();
diff --git a/user/groupextendenrol.php b/user/groupextendenrol.php
index fc30f1e..4438270 100755
--- a/user/groupextendenrol.php
+++ b/user/groupextendenrol.php
@@ -171,7 +171,7 @@ foreach ($_POST as $k => $v) {
         );
     }
 }
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 echo '<div style="width:100%;text-align:center;"><strong>';
 echo get_string('extendperiod') . ' ';
 echo html_writer::select($periodmenu, 'extendperiod');
diff --git a/user/index.php b/user/index.php
index a583547..2da4df0 100644
--- a/user/index.php
+++ b/user/index.php
@@ -214,7 +214,7 @@
 
 /// Print settings and things in a table across the top
     $controlstable = new html_table();
-    $controlstable->add_class('controls');
+    $controlstable->attributes['class'] = 'controls';
     $controlstable->cellspacing = 0;
     $controlstable->data[] = new html_table_row();
 
@@ -318,23 +318,23 @@
     $select = new single_select($baseurl, 'mode', $formatmenu, $mode, null, 'formatmenu');
     $select->set_label(get_string('userlist'));
     $userlistcell = new html_table_cell();
-    $userlistcell->add_class('right');
+    $userlistcell->attributes['class'] = 'right';
     $userlistcell->text = $OUTPUT->render($select);
     $controlstable->data[0]->cells[] = $userlistcell;
 
-    echo $OUTPUT->table($controlstable);
+    echo html_writer::table($controlstable);
 
     if ($currentgroup and (!$isseparategroups or has_capability('moodle/site:accessallgroups', $context))) {    /// Display info about the group
         if ($group = groups_get_group($currentgroup)) {
             if (!empty($group->description) or (!empty($group->picture) and empty($group->hidepicture))) {
                 $groupinfotable = new html_table();
-                $groupinfotable->add_class('groupinfobox');
+                $groupinfotable->attributes['class'] = 'groupinfobox';
                 $picturecell = new html_table_cell();
-                $picturecell->add_classes(array('left', 'side', 'picture'));
+                $picturecell->attributes['class'] = 'left side picture';
                 $picturecell->text = print_group_picture($group, $course->id, true, false, false);
 
                 $contentcell = new html_table_cell();
-                $contentcell->add_class('content');
+                $contentcell->attributes['class'] = 'content';
                 $contentcell->text = print_group_picture($group, $course->id, true, false, false);
 
                 $contentheading = $group->name;
@@ -349,7 +349,7 @@
                 }
                 $contentcell->text = $OUTPUT->heading($contentheading, 3) . format_text($group->description, $group->descriptionformat);
                 $groupinfotable->data[] = new html_table_row(array($picturecell, $contentcell));
-                echo $OUTPUT->table($groupinfotable);
+                echo html_writer::table($groupinfotable);
             }
         }
     }
@@ -751,15 +751,15 @@
                         $hiddenfields = array_flip(explode(',', $CFG->hiddenuserfields));
                     }
                     $table = new html_table();
-                    $table->add_class('userinfobox');
+                    $table->attributes['class'] = 'userinfobox';
 
                     $row = new html_table_row();
                     $row->cells[0] = new html_table_cell();
-                    $row->cells[0]->add_class('left side');
+                    $row->cells[0]->attributes['class'] = 'left side';
 
                     $row->cells[0]->text = $OUTPUT->user_picture($user, array('courseid'=>$course->id));
                     $row->cells[1] = new html_table_cell();
-                    $row->cells[1]->add_class('content');
+                    $row->cells[1]->attributes['class'] = 'content';
 
                     $row->cells[1]->text = $OUTPUT->container(fullname($user, has_capability('moodle/site:viewfullnames', $context)), 'username');
                     $row->cells[1]->text .= $OUTPUT->container_start('info');
@@ -797,7 +797,7 @@
                     $row->cells[1]->text .= $OUTPUT->container_end();
 
                     $row->cells[2] = new html_table_cell();
-                    $row->cells[2]->add_class('links');
+                    $row->cells[2]->attributes['class'] = 'links';
                     $row->cells[2]->text = '';
 
                     $links = array();
@@ -831,7 +831,7 @@
                         $row->cells[2]->text .= '<br /><input type="checkbox" name="user'.$user->id.'" /> ';
                     }
                     $table->data = array($row);
-                    echo $OUTPUT->table($table);
+                    echo html_writer::table($table);
                 }
 
             } else {
diff --git a/user/managetoken.php b/user/managetoken.php
index ccc9365..b900ce4 100644
--- a/user/managetoken.php
+++ b/user/managetoken.php
@@ -175,7 +175,7 @@ switch ($action) {
 
                 $table->data[] = array($token->token, $token->name, $validuntil, $creatoratag, $reset);
             }
-            $return .= $OUTPUT->table($table);
+            $return .= html_writer::table($table);
           
         } else {
             $return .= get_string('notoken', 'webservice');
diff --git a/user/portfolio.php b/user/portfolio.php
index 708ec30..dac0699 100644
--- a/user/portfolio.php
+++ b/user/portfolio.php
@@ -119,7 +119,7 @@ if ($display) {
         );
     }
 
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
     echo $OUTPUT->box_end();
 }
 echo $OUTPUT->footer();
diff --git a/user/portfoliologs.php b/user/portfoliologs.php
index 3c3017e..76b15c4 100644
--- a/user/portfoliologs.php
+++ b/user/portfoliologs.php
@@ -101,7 +101,7 @@ if (count($queued) > 0) {
         unset($e); // this could potentially be quite big, so free it.
     }
     echo $OUTPUT->heading(get_string('queuesummary', 'portfolio'));
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
     $somethingprinted = true;
 }
 // paging - get total count separately
@@ -139,7 +139,7 @@ if ($logcount > 0) {
     echo $OUTPUT->heading(get_string('logsummary', 'portfolio'));
     $pagingbar = new paging_bar($logcount, $page, $perpage, $CFG->wwwroot . '/user/portfoliologs.php?');
     echo $OUTPUT->render($pagingbar);
-    echo $OUTPUT->table($table);
+    echo html_writer::table($table);
     echo $OUTPUT->render($pagingbar);
     $somethingprinted = true;
 }
diff --git a/user/profile/index.php b/user/profile/index.php
index 5da6d54..93ac676 100644
--- a/user/profile/index.php
+++ b/user/profile/index.php
@@ -120,7 +120,7 @@ foreach ($categories as $category) {
     $table->head  = array(get_string('profilefield', 'admin'), get_string('edit'));
     $table->align = array('left', 'right');
     $table->width = '95%';
-    $table->add_class ('generaltable profilefield');
+    $table->attributes['class'] = 'generaltable profilefield';
     $table->data = array();
 
     if ($fields = $DB->get_records('user_info_field', array('categoryid'=>$category->id), 'sortorder ASC')) {
@@ -131,7 +131,7 @@ foreach ($categories as $category) {
 
     echo $OUTPUT->heading(format_string($category->name) .' '.profile_category_icons($category));
     if (count($table->data)) {
-        echo $OUTPUT->table($table);
+        echo html_writer::table($table);
     } else {
         echo $OUTPUT->notification($strnofields);
     }
diff --git a/user/repository.php b/user/repository.php
index 8bd205e..2046d14 100644
--- a/user/repository.php
+++ b/user/repository.php
@@ -83,7 +83,7 @@ foreach ($instances as $i) {
             .get_string('settings', 'repository').'</a>' : '');
 }
 
-echo $OUTPUT->table($table);
+echo html_writer::table($table);
 echo $OUTPUT->footer();
 
 
